features:
  primary:
  - name: "Allow Deploy Keys to push to protected branches"
    available_in: [core, premium, ultimate]
    gitlab_com: true
    documentation_link: 'https://docs.gitlab.com/ee/user/project/repository/branches/protected.html#allow-deploy-keys-to-push-to-a-protected-branch'
    image_url: "/images/13_9/deploy_keys.png"
    reporter: ogolowinski
    stage: deploy
    categories:
    - 'Continuous Delivery'
    issue_url: 'https://gitlab.com/gitlab-org/gitlab/-/issues/30769'
    description: |
      Prior to GitLab 12.0, Deploy Keys with write access could push commits to protected branches. Support for this was removed due to security concerns, but many users still requested it, as they were using it to ensure that only users with Deploy Keys could push to their repositories. It also eliminates the need to use a service user or machine user, which ties up a license for any team that wants to allow Deploy Keys to push to protected branches just for this use case. We are excited to announce that we resolved this issue and now Deploy Keys can push to protected branches once more while abiding by security best practices. By moving towards an isolated permission model for Deploy Keys, users can now select Deploy Keys to link to protected branches directly from the settings page on protected branches.
